package compute

import (
	"context"
	"net/http"
	"strings"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// SnapshotCreateRequest struct to create snapshot
type SnapshotCreateRequest struct {
	// ID of the compute instance to create snapshot for
	// Required: true
	ComputeID uint64 `url:"computeId" json:"computeId" validate:"required"`

	// Text label for snapshot.
	// Must be unique among this compute snapshots
	// Allowed characters: a-z, 0-9, spaces, punctuation except '<' and '>'
	// Maximum length: 36 characters
	// Required: true
	Label string `url:"label" json:"label" validate:"required,max=36,excludesall=<>"`

	// Create snapshot with memory dump
	// Required: false
	// Default: false
	WithMemory bool `url:"with_memory" json:"with_memory"`
}

type wrapperSnapshotCreateRequest struct {
	SnapshotCreateRequest
	AsyncMode bool `url:"asyncMode"`
}

// SnapshotCreate creates compute snapshot
func (c Compute) SnapshotCreate(ctx context.Context, req SnapshotCreateRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperSnapshotCreateRequest{
		SnapshotCreateRequest: req,
		AsyncMode:             false,
	}

	url := "/cloudbroker/compute/snapshotCreate"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	result := strings.ReplaceAll(string(res), "\"", "")

	return result, nil
}

// SnapshotCreateAsync creates compute snapshot in async mode
func (c Compute) SnapshotCreateAsync(ctx context.Context, req SnapshotCreateRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperSnapshotCreateRequest{
		SnapshotCreateRequest: req,
		AsyncMode:             true,
	}

	url := "/cloudbroker/compute/snapshotCreate"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
